import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CancelUpdateStackInput } from "../models/models_0";
import { deserializeAws_queryCancelUpdateStackCommand, serializeAws_queryCancelUpdateStackCommand, } from "../protocols/Aws_query";
var CancelUpdateStackCommand = (function (_super) {
    __extends(CancelUpdateStackCommand, _super);
    function CancelUpdateStackCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CancelUpdateStackCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "CancelUpdateStackCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CancelUpdateStackInput.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CancelUpdateStackCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryCancelUpdateStackCommand(input, context);
    };
    CancelUpdateStackCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryCancelUpdateStackCommand(output, context);
    };
    return CancelUpdateStackCommand;
}($Command));
export { CancelUpdateStackCommand };
