import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeStackDriftDetectionStatusInput, DescribeStackDriftDetectionStatusOutput } from "../models/models_0";
import { deserializeAws_queryDescribeStackDriftDetectionStatusCommand, serializeAws_queryDescribeStackDriftDetectionStatusCommand, } from "../protocols/Aws_query";
var DescribeStackDriftDetectionStatusCommand = (function (_super) {
    __extends(DescribeStackDriftDetectionStatusCommand, _super);
    function DescribeStackDriftDetectionStatusCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeStackDriftDetectionStatusCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "DescribeStackDriftDetectionStatusCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeStackDriftDetectionStatusInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeStackDriftDetectionStatusOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeStackDriftDetectionStatusCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeStackDriftDetectionStatusCommand(input, context);
    };
    DescribeStackDriftDetectionStatusCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeStackDriftDetectionStatusCommand(output, context);
    };
    return DescribeStackDriftDetectionStatusCommand;
}($Command));
export { DescribeStackDriftDetectionStatusCommand };
