import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeStackSetOperationInput, DescribeStackSetOperationOutput } from "../models/models_0";
import { deserializeAws_queryDescribeStackSetOperationCommand, serializeAws_queryDescribeStackSetOperationCommand, } from "../protocols/Aws_query";
var DescribeStackSetOperationCommand = (function (_super) {
    __extends(DescribeStackSetOperationCommand, _super);
    function DescribeStackSetOperationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeStackSetOperationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "DescribeStackSetOperationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeStackSetOperationInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeStackSetOperationOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeStackSetOperationCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeStackSetOperationCommand(input, context);
    };
    DescribeStackSetOperationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeStackSetOperationCommand(output, context);
    };
    return DescribeStackSetOperationCommand;
}($Command));
export { DescribeStackSetOperationCommand };
