import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { CreateChangeSetInput, CreateChangeSetOutput } from "../models/models_0";
export interface CreateChangeSetCommandInput extends CreateChangeSetInput {
}
export interface CreateChangeSetCommandOutput extends CreateChangeSetOutput, __MetadataBearer {
}

export declare class CreateChangeSetCommand extends $Command<CreateChangeSetCommandInput, CreateChangeSetCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: CreateChangeSetCommandInput;
    constructor(input: CreateChangeSetCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateChangeSetCommandInput, CreateChangeSetCommandOutput>;
    private serialize;
    private deserialize;
}
