import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { ListStackResourcesInput, ListStackResourcesOutput } from "../models/models_0";
export interface ListStackResourcesCommandInput extends ListStackResourcesInput {
}
export interface ListStackResourcesCommandOutput extends ListStackResourcesOutput, __MetadataBearer {
}

export declare class ListStackResourcesCommand extends $Command<ListStackResourcesCommandInput, ListStackResourcesCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: ListStackResourcesCommandInput;
    constructor(input: ListStackResourcesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListStackResourcesCommandInput, ListStackResourcesCommandOutput>;
    private serialize;
    private deserialize;
}
